package org.implab.gradle.containers.tasks;

import java.util.List;
import java.util.concurrent.Callable;

import org.gradle.api.provider.ListProperty;
import org.gradle.api.provider.Property;
import org.gradle.api.tasks.Input;
import org.gradle.api.tasks.Optional;
import org.implab.gradle.containers.ImageName;

public abstract class PushImage extends CliTask {

    @Input
    public abstract Property<ImageName> getImageName();

    @Input
    @Optional
    public abstract Property<String> getTransport();

    @Input
    @Optional
    public abstract ListProperty<String> getOptions();

    public PushImage option(Callable<String> provider) {
        getOptions().add(getProject().provider(provider));
        return this;
    }

    @Override
    protected void preparingCommand(List<String> commandLine) {
        super.preparingCommand(commandLine);

        commandLine.add("push");
        commandLine.addAll(getOptions().get());
        commandLine.add(getImageName().get().toString());
    }
}
